﻿<?php
/*************************************************************
* bitpay payment                                            *
* http://bitpay.ir                                          *
* Copyright (c) 2011 bitpay.ir                              *
* AUTHOR bitpay developement team ( info[at]bitpay[dot]ir )*
**************************************************************/

class osC_Payment_bitpay extends osC_Payment {
	var $_title, $_code = 'bitpay', $_status = false, $_sort_order, $_order_id,$go;
    function send($url,$api,$amount,$redirect){
        $ch = curl_init();
        curl_setopt($ch,CURLOPT_URL,"$url");
        curl_setopt($ch,CURLOPT_POSTFIELDS,"api=$api&amount=$amount&redirect=$redirect");
        curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, FALSE);
        curl_setopt($ch,CURLOPT_RETURNTRANSFER,true);
        $res = curl_exec($ch);
        curl_close($ch);
        return $res;
    }
    function get($url,$api,$trans_id,$id_get){
        $ch = curl_init();
        curl_setopt($ch,CURLOPT_URL,"$url");
        curl_setopt($ch,CURLOPT_POSTFIELDS,"api=$api&id_get=$id_get&trans_id=$trans_id");
        curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, FALSE);
        curl_setopt($ch,CURLOPT_RETURNTRANSFER,true);
        $res = curl_exec($ch);
        curl_close($ch);
        return $res;
    }
	function osC_Payment_bitpay() {
		global $osC_Database, $osC_Language, $osC_ShoppingCart;
		$this->_title = $osC_Language->get('پرداخت اينترنتي bitpay');
		$this->_method_title = $osC_Language->get('پرداخت اينترنتي bitpay');
		$this->_status = (MODULE_PAYMENT_bitpay_STATUS == '1') ? true : false;
		$this->_sort_order = MODULE_PAYMENT_bitpay_SORT_ORDER;
		$this->form_action_url = 'https://bitpay.ir/payment/gateway-'.$go;
		if ($this->_status === true) {
			if ((int) MODULE_PAYMENT_bitpay_ORDER_STATUS_ID > 0) {
				$this->order_status = MODULE_PAYMENT_bitpay_ORDER_STATUS_ID;
			}
			if ((int) MODULE_PAYMENT_bitpay_ZONE > 0) {
				$check_flag = false;
				$Qcheck = $osC_Database->query('select zone_id from :table_zones_to_geo_zones where geo_zone_id = :geo_zone_id and zone_country_id = :zone_country_id order by zone_id');
				$Qcheck->bindTable(':table_zones_to_geo_zones', TABLE_ZONES_TO_GEO_ZONES);
				$Qcheck->bindInt(':geo_zone_id', MODULE_PAYMENT_bitpay_ZONE);
				$Qcheck->bindInt(':zone_country_id', $osC_ShoppingCart->getBillingAddress('country_id'));
				$Qcheck->execute();
				while ($Qcheck->next()) {
					if ($Qcheck->valueInt('zone_id') < 1) {
						$check_flag = true;
						break;
					}
					elseif ($Qcheck->valueInt('zone_id') == $osC_ShoppingCart->getBillingAddress('zone_id')) {
						$check_flag = true;
						break;
					}
				}
				if ($check_flag === false) {
					$this->_status = false;
				}
			}
		}
	}
	function selection() {
		return array('id' => $this->_code, 'module' => $this->_method_title);
	}
	function pre_confirmation_check() {
		return false;
	}
	function confirmation() {
		global $osC_Language, $osC_CreditCard;
		$this->_order_id = osC_Order :: insert(ORDERS_STATUS_PREPARING);
		$confirmation = array('title' => $this->_method_title, 'fields' => array(array('title' => $osC_Language->get('پرداخت آنلاین با bitpay.ir '))));
		return $confirmation;
	}
	function process_button() {
		global $osC_Currencies, $osC_ShoppingCart, $osC_Language, $osC_Database;
		if (MODULE_PAYMENT_bitpay_CURRENCY == 'Selected Currency') {
			$currency = $osC_Currencies->getCode();
		}
		else {
			$currency = MODULE_PAYMENT_bitpay_CURRENCY;
		}
		$amount = round($osC_Currencies->formatRaw($osC_ShoppingCart->getTotal(), $currency), 2);
		$order = $this->_order_id;
		$amount = $amount;
		$orderId = $order;
		$status = 1;
		$callbackUrl = urlencode(osc_href_link(FILENAME_CHECKOUT, 'process', 'HTTP', null, null, true));

		$url = 'https://bitpay.ir/payment/gateway-send';
        $api = MODULE_PAYMENT_bitpay_PIN;
		$result = $this->send($url,$api,$amount,$callbackUrl);
        $go = $result;
        if($result > 0 && is_numeric($result)){

		    $osC_Database->simpleQuery("insert into `" . DB_TABLE_PREFIX . "online_transactions`(orders_id,receipt_id,transaction_method,transaction_date,transaction_amount,transaction_id) values('$order','$result','bitpay','','$amount','')");
			//
			echo '<div style="text-align:left;">' . osc_link_object(osc_href_link('https://bitpay.ir/payment/gateway-' . $result, '', '', '', false), osc_draw_image_button('button_confirm_order.gif', $osC_Language->get('button_confirm_order'), 'id="btnConfirmOrder"')) . '</div><div style="display:none">';
		}
		else {
		    // log error in app
			// Update table, log the error
			osC_Order :: remove($this->_order_id);
			echo '<div style="font-size:11px; color:#cc0000; width:500; border:1px solid #cc0000; padding:5px; background:#ffffcc;">' . check_bitpay_state_error($result) . '</div><div style="display:none">';
		}

	}
	function get_error() {
		global $osC_Language;
		return $error;
	}
	function process() {
		global $osC_Language, $osC_Customer, $osC_ShoppingCart, $_POST, $_GET, $messageStack, $osC_Database;
        $url = 'https://bitpay.ir/payment/gateway-result-second';
        $api = MODULE_PAYMENT_bitpay_PIN;
        $trans_id = $_POST['trans_id'];
        $id_get = $_POST['id_get'];
        $result = $this->get($url,$api,$trans_id,$id_get);
        if($result == 1){
		    $osC_Database->simpleQuery("update `" . DB_TABLE_PREFIX . "online_transactions` set transaction_id = '$trans_id',transaction_date = '" . date("YmdHis") . "' where 1 and ( receipt_id = '$id_get' )");

			$Qtransaction = $osC_Database->query('insert into :table_orders_transactions_history (orders_id, transaction_code, transaction_return_value, transaction_return_status, date_added) values (:orders_id, :transaction_code, :transaction_return_value, :transaction_return_status, now())');
			$Qtransaction->bindTable(':table_orders_transactions_history', TABLE_ORDERS_TRANSACTIONS_HISTORY);
			$Qtransaction->bindInt(':orders_id', $order);
			$Qtransaction->bindInt(':transaction_code', 1);
			$Qtransaction->bindValue(':transaction_return_value', $id_get);
			$Qtransaction->bindInt(':transaction_return_status', 1);
			$Qtransaction->execute();
			//
			$this->_order_id = osC_Order :: insert();
			$comments = $osC_Language->get('payment_bitpay_method_authority') . '[' . $trans_id . ']';
			osC_Order :: process($this->_order_id, $this->order_status, $comments);
		}
		else {
	        $order = $this->_order_id;
			$orderid = $order;
			$reversaltoreversal = $order;
			$reversalstatus = 1;
			$osC_Database->simpleQuery("delete from `" . DB_TABLE_PREFIX . "online_transactions` where 1 and ( receipt_id = '$id_get' ) and ( orders_id = '$order' )");
			//
			osC_Order :: remove($this->_order_id);
			$messageStack->add_session('checkout', 'خطا در تایید تراکنش ، مبلغ تراکنش با موفقیت به حساب شما برگشت داده شد.', 'error');
			osc_redirect(osc_href_link(FILENAME_CHECKOUT, 'checkout&view=paymentInformationForm', 'SSL', null, null, true));
		    }
								// end Display the result
		}

	function callback() {
		global $osC_Database;
		//
	}
}
function check_bitpay_state_error($status) {
	switch ($status) {
		case '-1' :
			$pay_error = "api ارسالی با نوع api تعریف شده در bitpay سازگار نیست.";
			break;
		DEFAULT :
			$pay_error = "خطاي نامشخص [خطاي شماره : $status]";
	}
	return '<b>خطا شماره ' . $status . ' :</b> ' . $pay_error;
}
?>